const taskList = [];
let maxNumberOfRunnigTasks=20;
let numberOfRunnigTasks = 0;

// task = {
//     taskTyp: "string",
//     executor: "function, return promise",
// maxRetries:"int"
// }

function addTask(task) {
    console.log('New task added ', task.name)
    taskList.push(task);
    handleTask()
}

function taskCompleted(task, result) {
    console.log('task completed : ', task.name )
    numberOfRunnigTasks--;
    handleTask()

}
function taskFailed(task, error) {
    console.log('task failed : ', task.name )
    numberOfRunnigTasks--;
    if (task.maxRetries > task.retries) {
        task.retries++;
        addTask(task)
        return
    }
    handleTask()
}

function execute(task) {
    console.log('Execute new task ', task.name)
    task.executor().then((result)=> {
        taskCompleted(task, result)
    }).catch((error)=> {
        taskFailed(task, error)
    })
}

function canRunTask() {
    return maxNumberOfRunnigTasks > numberOfRunnigTasks;
}

function handleTask() {
    if (canRunTask() &&  taskList.length == 0) {
        console.log('No more tasks')
        process.exit()
        return
    }else if (canRunTask()){
        numberOfRunnigTasks++;
        let currentTask = taskList.shift();
        execute(currentTask)
    }


}

module.exports={
    addTask
};


